
// ATtiny2313 @ 8MHz

#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include "fuart.h"
#include "dht11.c"

#define DDR_LED1	DDRB
#define PORT_LED1	PORTB
#define LED1		PB2
#define led1_to 	PORT_LED1 ^= (1 << LED1); 
#define led1_an		PORT_LED1 |= (1 << LED1);
#define led1_aus 	PORT_LED1 &= ~(1 << LED1);

char itoastr[4];

int main(void)
{
	PORT_DHT11 &= ~(1 << DHT11);
	DDR_LED1 |= (1 << LED1);
	fuart_ini(UBRR_VAL);
#if TX_INTERRUPT || RX_INTERRUPT	// uart mit Interrupt 
	sei();	
#endif	// TX_INTERRUPT
	fuart_puts("DHT11 Test\r");
	for(uint8_t i=0;i<16;i++) {led1_to; _delay_ms(100);}

	while(42)
	{	
		unsigned char feuchte=0; 
		unsigned char temperatur=0;	
		led1_an;
		uint8_t error = dht11(&feuchte, &temperatur);
		if (!error)
		{
			fuart_puts (itoa( feuchte, itoastr, 10 )); fuart_putc('%'); fuart_putc(' ');
			fuart_puts (itoa( temperatur, itoastr, 10 )); fuart_putc('C'); fuart_putc(13);		
		}
		else
		{
			fuart_puts ("Error"); fuart_puts (itoa( error, itoastr, 10 )); fuart_putc(',');		
		}
		
		led1_aus;
		_delay_ms(2000);
	}	
}

